open Util

open Format

module This = struct
  type t = string

  let compare = String.compare

  let equal = ( = )
end

include This

module Set = Set.Make (This)

module Map = Map.Make (This)

let counter = ref 0

let fresh () =
  incr counter;
  sprintf "^%d" !counter

let fresh_wrt v s =
  let rec search_name v i =
    if Set.mem v s then
      search_name (sprintf "%s%i" v i) (succ i)
    else
      v in
  search_name v 1

let format fmt v = fprintf fmt "%s" v
